REM INFO: Tile Animator.csc v1.6.0 (PPX3)
REM Copyright  James Aswell, 2000-2002
REM 
REM DESCRIPTION:
REM Create a scrolling animation from a tiling image.

DECLARE FUNCTION LCM ( x&, y& ) AS LONG

Global AnimMode%, xFolder$

xFolder$ = GETSCRIPTFOLDER() + "\"

BEGIN DIALOG OBJECT Dialog1 82, 157, "Tile Animator", SUB AnimX
	OPTIONGROUP .OptionGroup1Val%
		OPTIONBUTTON  12, 17, 58, 10, .OptionButton1, "North"
		OPTIONBUTTON  12, 28, 58, 10, .OptionButton2, "North East"
		OPTIONBUTTON  12, 39, 58, 10, .OptionButton3, "East"
		OPTIONBUTTON  12, 50, 58, 10, .OptionButton4, "South East"
		OPTIONBUTTON  12, 61, 58, 10, .OptionButton5, "South"
		OPTIONBUTTON  12, 72, 58, 10, .OptionButton6, "South West"
		OPTIONBUTTON  12, 83, 58, 10, .OptionButton7, "West"
		OPTIONBUTTON  12, 95, 58, 10, .OptionButton8, "North West"
	GROUPBOX  2, 5, 77, 108, .GroupBox1, "Direction"
	PUSHBUTTON  12, 119, 60, 14, .PushButton1, "Ok"
	PUSHBUTTON  12, 139, 60, 14, .PushButton2, "Cancel"
END DIALOG

WITHOBJECT "CorelPhotoPaint.Automation.13"

ON ERROR GOTO ERRORHANDLER

Filename$ = GETFILEBOX("Image Files|*.GIF;*.JPG;*.BMP;*.CPT;*.TIF;*.PCX|All Files|*.*", "Files...", 0,"")

IF Filename$ = "" THEN STOP

ret% = Dialog(Dialog1)

IF ret% > 3 THEN

		.FileOpen Filename$, 0, 0, 0, 0, 0, 1, 1 

		.ObjectMerge TRUE
			.EndObject

		.MaskRemove

		.EditCopy
		.FileClose
		.EditPasteDocument
		.BindToActiveDocument

		docX& = .GetDocumentWidth()
		docY& = .GetDocumentHeight()

		IF ret% < 4 OR ret% > 11 THEN STOP
		
		SELECT CASE ret%
			CASE 4, 8
				zx% = 0
			CASE 5, 6, 7
				zx% = 1
			CASE 9, 10, 11
				zx% = -1
		END SELECT
		
		SELECT CASE ret%
			CASE 4, 5, 11
				zy% = -1
			CASE 6, 10
				zy% = 0
			CASE 7, 8, 9
				zy% = 1
		END SELECT
		
		SELECT CASE ret%
			CASE 4, 8
				MOVLEN& = docY
			CASE 5, 7, 9, 11
				MOVLEN& = LCM( docX, docY )
			CASE 6, 10
				MOVLEN& = docX
		END SELECT

		IF MOVLEN& > 500 THEN
			IF MESSAGEBOX("To tile properly, this image will require " & MOVLEN & " frames!  Do you want to continue?", "Frame Length...", 1 OR 32) <> 1 THEN
				.FileClose
				STOP
			ENDIF
		ENDIF
		
		.MovieCreate

		FOR i% = 1 TO (MOVLEN-1) 'STEP 1
			.MovieInsertFrame i%, 1, FALSE, TRUE
			.BitmapEffect "Offset", "OffsetEffect OffsetHShift=" & zx% & ",OffsetVShift=" & zy% & ",OffsetAsPercent=0,OffsetMode=0,OffsetCS=5:0:0:0"
		NEXT i%

		.MovieGotoFrame 1

	END WITHOBJECT
ENDIF

STOP

SUB AnimX (BYVAL ControlID%, BYVAL Event%)
	IF Event% = 0 THEN
		AnimMode% = 4
	ELSEIF Event% = 2 THEN
		IF ControlID% > 1 AND ControlID% < 10 THEN
			AnimMode% = ControlID% + 2
		ELSEIF ControlID% = 11 THEN
			Dialog1.CLOSEDIALOG AnimMode%			
		ELSEIF ControlID% = 12 THEN
			Dialog1.CLOSEDIALOG 2
		ENDIF
	ENDIF
END SUB

FUNCTION LCM ( x&, y& ) AS LONG
	a& = x
	WHILE ( ( a MOD y ) <> 0 )
		a = a + x
	WEND
	LCM = a
END FUNCTION

ERRORHANDLER:
SELECT CASE ERRNUM
	CASE 603
		RESUME NEXT
	CASE ELSE
		MESSAGE "Unexpected Error:" + STR(ERRNUM)
		RESUME NEXT
END SELECT
